"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamicArrayField = void 0;
const react_1 = require("react");
const IFormBuilderListConfig_1 = require("../../../components/config/IFormBuilderListConfig");
const FormBuilder_1 = require("../../../components/FormBuilder");
const ValidationEventType_1 = require("../../../models/validation/ValidationEventType");
const ValidationMark_1 = require("../../../models/validation/ValidationMark");
const react_2 = __importDefault(require("react"));
const wrapValues = (values) => values === null || values === void 0 ? void 0 : values.map(_ => { return { value: _ }; });
const unwrapValues = (fakeItems) => fakeItems === null || fakeItems === void 0 ? void 0 : fakeItems.map(_ => _.value);
const DynamicArrayField = (props) => {
    var _a;
    const [items, setItems] = (0, react_1.useState)((_a = wrapValues(props.value)) !== null && _a !== void 0 ? _a : []);
    (0, react_1.useEffect)(() => { var _a; return setItems((_a = wrapValues(props.value)) !== null && _a !== void 0 ? _a : []); }, [props.value]);
    const getSchema = () => {
        var _a;
        var schema = {
            options: {
                validation: {
                    ignoreValidation: false,
                    validationRules: {
                        value: { id: "required", validationMark: ValidationMark_1.ValidationMark.Required, validationRule: (item) => item.value != null && item.value != "", validationMessage: "Value must be specified", validateOn: ValidationEventType_1.ValidationEventType.Blur | ValidationEventType_1.ValidationEventType.Manual },
                    }
                },
                properties: {
                    value: { propertyType: (_a = props.config) === null || _a === void 0 ? void 0 : _a.propertyType, displayName: "Value", config: { resizable: true } },
                }
            }
        };
        return schema;
    };
    const onChange = (fakeItems) => {
        const values = unwrapValues(fakeItems);
        props.onChange(values);
    };
    return (react_2.default.createElement(react_2.default.Fragment, null,
        react_2.default.createElement(FormBuilder_1.FormBuilder, { item: items, schemaConfig: { schemaProvider: { key: "fakeit", getSchema: () => __awaiter(void 0, void 0, void 0, function* () { return getSchema(); }) } }, listProps: {
                config: {
                    itemIdentifier: (item) => { var _a; return (_a = item === null || item === void 0 ? void 0 : item.value) === null || _a === void 0 ? void 0 : _a.toString(); },
                    multiSelect: true,
                    onItemsChange: (fakeItems) => onChange(fakeItems),
                },
                editorConfig: {
                    title: item => "Item",
                    type: IFormBuilderListConfig_1.FormBuilderListEditorType.Dialog
                },
                menuConfig: {
                    actions: (newItem, editItem, deleteItems) => ([
                        { title: "New", iconName: "Add", selectionMode: IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.None | IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.Single | IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.Multi, action: () => newItem() },
                        { title: "Edit", iconName: "Edit", selectionMode: IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.Single, action: () => editItem() },
                        { title: "Delete", iconName: "Delete", selectionMode: IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.Single | IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.Multi, action: () => deleteItems() },
                    ]),
                }
            }, overrideSchema: getSchema() })));
};
exports.DynamicArrayField = DynamicArrayField;
//# sourceMappingURL=DynamicArrayField.js.map