"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildPropertyRenderInfo = void 0;
const ValidationUtil_1 = require("../../utils/common/ValidationUtil");
const buildPropertyRenderInfo = (renderProps, schema, propertyName) => {
    var _a;
    let { item, onChange, onBlur, validationResults, validationResultPrefix } = renderProps;
    let validationIndexer = validationResultPrefix ? `${validationResultPrefix}.${propertyName}` : propertyName;
    let key = `prop-${validationResultPrefix !== null && validationResultPrefix !== void 0 ? validationResultPrefix : ""}${propertyName}`;
    let props = {
        key: (_a = schema.key) !== null && _a !== void 0 ? _a : key,
        value: item[propertyName],
        propertyName: propertyName,
        options: schema,
        onChange: (value) => onChange(propertyName, value),
        onBlur: (value) => onBlur(propertyName, value),
        disabled: schema.disable ? schema.disable(item) : false,
        errorMessage: ValidationUtil_1.validationUtil.getResultAsString(validationResults[validationIndexer]),
        parent: item
    };
    return { props, key };
};
exports.buildPropertyRenderInfo = buildPropertyRenderInfo;
//# sourceMappingURL=BuildPropertyRenderProps.js.map