"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formListHelper = void 0;
const IFormBuilderListConfig_1 = require("../../components/config/IFormBuilderListConfig");
const copyAndSort = (items, property, isSortedDescending) => {
    let key = property;
    // key = (key as any).replace("column-", ""); // replace prefix from column key
    return items.slice(0).sort((a, b) => ((isSortedDescending ? a[key] < b[key] : a[key] > b[key]) ? 1 : -1));
};
const filterColumns = (propKeys, options) => {
    if ((options === null || options === void 0 ? void 0 : options.columns) == null || (options === null || options === void 0 ? void 0 : options.pickType) == null)
        return propKeys;
    if (options.pickType == IFormBuilderListConfig_1.FormListColumnsPickType.Only)
        return propKeys.filter(_ => options === null || options === void 0 ? void 0 : options.columns.includes(_));
    else if (options.pickType == IFormBuilderListConfig_1.FormListColumnsPickType.Without)
        return propKeys.filter(_ => !(options === null || options === void 0 ? void 0 : options.columns.includes(_)));
    else
        return propKeys;
};
const isMenuItemDisabled = (selectionMode, selectedItemsLength) => {
    let disabled = true;
    if ((selectionMode & IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.None) === IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.None)
        disabled = selectedItemsLength !== 0;
    if ((selectionMode & IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.Single) === IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.Single)
        disabled = disabled && selectedItemsLength !== 1;
    if ((selectionMode & IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.Multi) === IFormBuilderListConfig_1.IFormBuilderListMenuItemSelectionMode.Multi)
        disabled = disabled && selectedItemsLength < 2;
    return disabled;
};
exports.formListHelper = { copyAndSort, filterColumns, isMenuItemDisabled };
//# sourceMappingURL=FormListHelper.js.map