"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormBuilder = void 0;
const react_1 = __importStar(require("react"));
const ValidationEventType_1 = require("../models/validation/ValidationEventType");
const Form_1 = require("./Form");
const FormList_1 = require("./FormList");
const FormBuilderInitializer_1 = require("../utils/FormBuilderInitializer");
const schemaFromConfig_1 = require("../utils/schema/schemaFromConfig");
// wrapper for handling both single item and list of items
// export const FormBuilder = forwardRef(<T extends IFormItem, FormBuilderRef>(props : IFormBuilderProps<T>, ref: FormBuilderRef) => {
const FormBuilder = (props) => {
    var _a, _b;
    // verify that the formbuilder is set up correctly
    FormBuilderInitializer_1.formbuilder.verify();
    const [item, setItem] = (0, react_1.useState)(props.item);
    const subFormRef = (0, react_1.useRef)();
    const [schema, setSchema] = (0, react_1.useState)(props.overrideSchema);
    (0, react_1.useImperativeHandle)(props.formRef, () => ({
        getItem: () => { var _a; return (_a = subFormRef.current) === null || _a === void 0 ? void 0 : _a.getItem(); },
        validateItem: () => { var _a, _b; return ((_a = subFormRef.current) === null || _a === void 0 ? void 0 : _a.validateItem) != null ? (_b = subFormRef.current) === null || _b === void 0 ? void 0 : _b.validateItem(ValidationEventType_1.ValidationEventType.Manual) : undefined; }
    }), []);
    const loadSchema = () => __awaiter(void 0, void 0, void 0, function* () {
        let schemaMerged = yield (0, schemaFromConfig_1.schemaFromConfig)(props.schemaConfig, props.formItemConfigOverrides, props.propertyOverrides);
        setSchema(schemaMerged);
    });
    (0, react_1.useEffect)(() => {
        setItem(props.item);
    }, [props.item]);
    (0, react_1.useEffect)(() => {
        if (props.overrideSchema == null)
            loadSchema();
    }, [props.schemaConfig]);
    if (schema == null)
        return null;
    const getKey = () => {
        return `${props.keyPrefix}`;
    };
    return (react_1.default.createElement("div", { className: "formbuilder-rootcontainer", key: `${props.keyPrefix}-formbuilder-container` }, (Array.isArray(props.item) || props.listProps != null)
        ? react_1.default.createElement(FormList_1.FormList, Object.assign({ key: getKey(), ref: subFormRef, items: item, schema: schema }, props, { listProps: (_a = props.listProps) !== null && _a !== void 0 ? _a : schema.options.listOptions, keyPrefix: `${props.keyPrefix}-list`, readOnly: ((_b = props.propertyOverrides) === null || _b === void 0 ? void 0 : _b.disabledProps) === true }))
        : react_1.default.createElement(Form_1.Form, Object.assign({ key: getKey(), ref: subFormRef, schema: schema, item: item, onPropertyChange: (item, prop, value) => { var _a; return ((_a = props.singleItemProps) === null || _a === void 0 ? void 0 : _a.onPropertyChange) == null ? () => { } : props.singleItemProps.onPropertyChange(item, prop, value); } }, props, { keyPrefix: getKey() }))));
};
exports.FormBuilder = FormBuilder;
//# sourceMappingURL=FormBuilder.js.map