"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formbuilder = void 0;
const FormItemRender_1 = require("../components/helpers/FormItemRender");
const Language_1 = require("../models/language/Language");
const String_1 = require("./common/String");
const ComplexObjectBuilder_1 = require("../builders/custom/ComplexObjectBuilder");
const schemaRegister = {};
exports.formbuilder = {
    formItemRender: undefined,
    initialize: () => {
        exports.formbuilder.formItemRender = (0, FormItemRender_1.buildFormItemRender)();
        return exports.formbuilder;
    },
    usingComplexBuilder: (labelRender, validationMsgElement, loadingSpinner) => {
        var _a;
        (_a = exports.formbuilder.formItemRender) === null || _a === void 0 ? void 0 : _a.register((0, ComplexObjectBuilder_1.createComplexObjectBuilder)(labelRender, validationMsgElement, loadingSpinner));
        return exports.formbuilder;
    },
    withBuilders: (...builders) => {
        var _a;
        (_a = exports.formbuilder.formItemRender) === null || _a === void 0 ? void 0 : _a.registerRange(builders);
        return exports.formbuilder;
    },
    withLanguage: (language) => {
        (0, Language_1.initLanguage)(language);
        return exports.formbuilder;
    },
    registerSchemaProvider: (provider) => {
        if (provider == null || String_1.strings.isNullOrWhiteSpace(provider.key))
            return;
        schemaRegister[provider.key] = provider;
    },
    getSchemaProvider: (key) => {
        return schemaRegister[key];
    },
    verify: () => {
        if (exports.formbuilder.formItemRender == null) // TODO: add link to init guide
            throw Error("Formbuilder not initialized! Call 'formBuilder.initialize' as early as possible");
        if (!exports.formbuilder.formItemRender.hasBuilders()) // TODO: add link to builders guide
            throw Error("Formbuilder hasn't got any builders! Please add one ore more builders. Either the standard ones or your own customs using 'withBuilders' and 'usingComplexBuilder'.");
        // all is well
    }
};
//# sourceMappingURL=FormBuilderInitializer.js.map