import { IDynamicComponentConfig } from "../builders/custom/config/IDynamicComponentConfig";
import { IFormItemComponentConfig } from "../builders/custom/config/IFormItemComponentConfig";
import { IDynamicArrayFieldConfig } from "../builders/custom/config/IDynamicArrayFieldConfig";
import { IFormItemPropertyOptions } from "../interfaces/options/IFormItemPropertyOptions";
import { AtLeast } from "../interfaces/types/Partials";
import { IFormItem } from "../interfaces/form/IFormItem";
import { IDynamicDateFieldConfig } from "../interfaces/fieldconfig/IDynamicDateFieldConfig";
import { IDynamicTextFieldConfig } from "../interfaces/fieldconfig/IDynamicTextfieldConfig";
import { IDynamicBooleanConfig } from "../interfaces/fieldconfig/IDynamicBooleanConfig";
import { IDynamicJsonFieldConfig } from "../interfaces/fieldconfig/IDynamicJsonfieldConfig";
import { IDynamicPredefinedArrayFieldConfig } from "../interfaces/fieldconfig/IDynamicPredefinedArrayFieldConfig";
export declare const propertyOptionsFactory: {
    string: <T extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T, IDynamicTextFieldConfig<T>>, "displayName">) => Partial<IFormItemPropertyOptions<T, IDynamicTextFieldConfig<T>>>;
    number: <T_1 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_1, IDynamicTextFieldConfig<T_1>>, "displayName">) => Partial<IFormItemPropertyOptions<T_1, IDynamicTextFieldConfig<T_1>>>;
    date: <T_2 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_2, IDynamicDateFieldConfig<T_2>>, "displayName">) => Partial<IFormItemPropertyOptions<T_2, IDynamicDateFieldConfig<T_2>>>;
    boolean: <T_3 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_3, IDynamicBooleanConfig<T_3>>, "displayName">) => Partial<IFormItemPropertyOptions<T_3, IDynamicBooleanConfig<T_3>>>;
    customComponent: <T_4 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_4, AtLeast<IDynamicComponentConfig<T_4>, "component">>, "displayName">) => Partial<IFormItemPropertyOptions<T_4, IDynamicComponentConfig<T_4>>>;
    formItem: <T_5 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_5, AtLeast<IFormItemComponentConfig<T_5>, "schemaConfig">>, "displayName">) => Partial<IFormItemPropertyOptions<T_5, IFormItemComponentConfig<T_5>>>;
    json: <T_6 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_6, IDynamicJsonFieldConfig<T_6>>, "displayName">) => Partial<IFormItemPropertyOptions<T_6, IDynamicJsonFieldConfig<T_6>>>;
    predefinedArray: <T_7 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_7, AtLeast<IDynamicPredefinedArrayFieldConfig<T_7>, "predefinedOptions">>, "displayName">) => Partial<IFormItemPropertyOptions<T_7, IDynamicPredefinedArrayFieldConfig<T_7>>>;
    array: <T_8 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_8, IDynamicArrayFieldConfig<T_8>>, "displayName">) => Partial<IFormItemPropertyOptions<T_8, IDynamicArrayFieldConfig<T_8>>>;
};
