"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.schemaFromConfig = void 0;
const SchemaFetch_1 = require("../common/SchemaFetch");
const schemaFromConfig = (schemaConfig, formItemConfigOverrides, propertyOverrides, dynamicKey) => __awaiter(void 0, void 0, void 0, function* () {
    let schema = undefined;
    if (schemaConfig.schemaProvider != null)
        schema = yield (0, SchemaFetch_1.fetchSchema)(schemaConfig.schemaProvider, formItemConfigOverrides, propertyOverrides, dynamicKey);
    else if (schemaConfig.registeredSchemaKey != null) {
        schema = yield (0, SchemaFetch_1.fetchSchemaFromMap)(schemaConfig.registeredSchemaKey, formItemConfigOverrides, propertyOverrides, dynamicKey);
        if (schema == null)
            throw Error("Schema not found in registered schemas. Please remember to register your schema by using 'formbuilder.registerSchema' or by supplying the schemaprovider directly in the formbuilder props using the 'schemaConfig' prop");
    }
    return schema;
});
exports.schemaFromConfig = schemaFromConfig;
//# sourceMappingURL=schemaFromConfig.js.map